.386
.model flat,stdcall

include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib

.data?
	hProcHeap dword ?
	ServiceTable dword ? ; http://msdn.microsoft.com/en-us/library/ms686001(VS.85).aspx
	hServiceStatus dword ?
	ServiceStatus dword ? ; http://msdn.microsoft.com/en-us/library/ms685996(VS.85).aspx

.code
	ServiceName byte "Service Name",0

start:
	call GetProcessHeap
	mov hProcHeap,eax

	push 8h
	push 8h
	push hProcHeap
	call HeapAlloc
	mov ServiceTable,eax

	push 1Ch
	push 8h
	push hProcHeap
	call HeapAlloc
	mov ServiceStatus,eax

	mov edx,ServiceTable
	mov [edx],offset ServiceName
	mov [edx+4],offset ServiceMain

	push ServiceTable
	call StartServiceCtrlDispatcher ; http://msdn.microsoft.com/en-us/library/ms686324(VS.85).aspx

	;---------------------------------------------
	; Clean up and exit

	push ServiceTable
	push 0h
	push hProcHeap
	call HeapFree

	push ServiceStatus
	push 0h
	push hProcHeap
	call HeapFree

	xor eax,eax
	ret
;===========================================================

ServiceMain proc
	push 0h
	push offset ServiceMsgHandler
	push offset ServiceName
	call RegisterServiceCtrlHandlerEx ; http://msdn.microsoft.com/en-us/library/ms685058(VS.85).aspx
	mov hServiceStatus,eax

	;mov edx,ServiceStatus
	;mov [edx],10h ; dwServiceType - SERVICE_WIN32_OWN_PROCESS
	;mov [edx+4],2h ; dwCurrentState - SERVICE_START_PENDING
	;mov [edx+8],1h ; dwControlsAccepted - stop/pause/restart - SERVICE_ACCEPT_STOP
	;mov [edx+12],0h ; dwWin32ExitCode
	;mov [edx+16],0h ; dwServiceSpecificExitCode
	;mov [edx+20],0h ; dwCheckPoint - increment for every subsequent START_PENDING update to reset time-out
	;mov [edx+24],30000 ; dwWaitHint - 30 second time-out for next operation and subsequent call to SetServiceStatus

	;---------------------------------------------
	; Initialize ServiceStatus structure

	mov edx,ServiceStatus
	mov [edx],dword ptr 10h ; dwServiceType - SERVICE_WIN32_OWN_PROCESS
	mov [edx+4],dword ptr 4h ; dwCurrentState - SERVICE_RUNNING
	mov [edx+8],dword ptr 1h ; dwControlsAccepted - SERVICE_ACCEPT_STOP
	mov [edx+12],dword ptr 0h ; dwWin32ExitCode
	mov [edx+16],dword ptr 0h ; dwServiceSpecificExitCode
	mov [edx+20],dword ptr 0h ; dwCheckPoint
	mov [edx+24],dword ptr 0 ; dwWaitHint - 0 seconds as we're running

	push ServiceStatus
	push hServiceStatus
	call SetServiceStatus ; http://msdn.microsoft.com/en-us/library/ms686241(VS.85).aspx

;~~~~~~~~~~~~~~
MAIN_SERVICE_LOOP:

	; do something here
	; enter loop and wait for status to be SERVICE_STOPPED, etc..

	push 5h
	call Sleep

	mov edx,ServiceStatus
	cmp [edx+4],dword ptr 1h ; SERVICE_STOPPED
	jnz MAIN_SERVICE_LOOP
;~~~~~~~~~~~~~~

	ret

ServiceMain endp

ServiceMsgHandler proc CtrlCode:DWORD, EventType:DWORD, EventData:DWORD, Context:DWORD
	mov eax,CtrlCode

	cmp eax,1h ; SERVICE_CONTROL_STOP
	jz STOP

	ret 10h

STOP:
	;---------------------------------------------
	; Update the service status

	mov edx,ServiceStatus
	mov [edx+4],dword ptr 1h ; dwCurrentState - SERVICE_STOPPED
	mov [edx+12],dword ptr 0h ; dwWin32ExitCode - no error

	push ServiceStatus
	push hServiceStatus
	call SetServiceStatus ; http://msdn.microsoft.com/en-us/library/ms686241(VS.85).aspx

	ret 10h

ServiceMsgHandler endp

end start